Index: branches/1.3/gui/scripts/nanovisviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/nanovisviewer.tcl	(revision 4848)
@@ -1220,53 +1199,65 @@
     }
     switch -- $what {
-        "-axesvisible" {
-            SendCmd "axis visible $_settings($what)"
-        }
-        "-background" {
-            set bgcolor [$itk_component(background) value]
-	    array set fgcolors {
-		"black" "white"
-		"white" "black"
-		"grey"	"black"
-	    }
-            configure -plotbackground $bgcolor \
-		-plotforeground $fgcolors($bgcolor)
- 	    DrawLegend $_current
-        }
-        "-colormap" {
+        light {
+            set val $_settings($this-light)
+            set diffuse [expr {0.01*$val}]
+            set ambient [expr {1.0-$diffuse}]
+            set specularLevel 0.3
+            set specularExp 90.0
+            SendCmd "volume shading ambient $ambient"
+            SendCmd "volume shading diffuse $diffuse"
+            SendCmd "volume shading specularLevel $specularLevel"
+            SendCmd "volume shading specularExp $specularExp"
+        }
+        light2side {
+            set val $_settings($this-light2side)
+            SendCmd "volume shading light2side $val"
+        }
+        transp {
+            set val $_settings($this-transp)
+            set sval [expr { 0.01 * double($val) }]
+            SendCmd "volume shading opacity $sval"
+        }
+        opacity {
+            set val $_settings($this-opacity)
+            set sval [expr { 0.01 * double($val) }]
+            foreach tf [array names _activeTfs] {
+                set _settings($this-$tf-opacity) $sval
+                set _activeTfs($tf) 0
+            }
+            updatetransferfuncs
+        }
+        thickness {
+            if { [array names _activeTfs] > 0 } {
+                set val $_settings($this-thickness)
+                # Scale values between 0.00001 and 0.01000
+                set sval [expr {0.0001*double($val)}]
+                foreach tf [array names _activeTfs] {
+                    set _settings($this-$tf-thickness) $sval
+                    set _activeTfs($tf) 0
+                }
+                updatetransferfuncs
+            }
+        }
+        "outline" {
+            SendCmd "volume outline state $_settings($this-outline)"
+        }
+        "isosurface" {
+            SendCmd "volume shading isosurface $_settings($this-isosurface)"
+        }
+        "colormap" {
             set color [$itk_component(colormap) value]
-            set _settings($what) $color
-            set _settings($_current${what}) $color
-            ResetColormap $_current $color
-        }
-        "-current" {
-            set cname [$itk_component(volcomponents) value]
-            SwitchComponent $cname
-        }
-        "-cutplanesvisible" {
-            set bool $_settings($what)
-            # We only set cutplanes on the first dataset.
-            set datasets [CurrentDatasets -cutplanes]
-            set tag [lindex $datasets 0]
-            if { $bool } {
-                foreach axis { x y z } {
-                    if { $_settings(-${axis}cutplanevisible) } {
-                        SendCmd "cutplane state 1 $axis $tag"
-                    }
-                }
-            } else {
-                foreach axis { x y z } {
-                    SendCmd "cutplane state 0 $axis $tag"
-                }
-            }
-        }
-        "-gridvisible" {
-            SendCmd "grid visible $_settings($what)"
-        }
-        "-isosurfaceshading" {
-            SendCmd "volume shading isosurface $_settings($what)"
-        }
-        "-legendvisible" {
-            if { $_settings($what) } {
+            set _settings(colormap) $color
+            # Only set the colormap on the first volume. Ignore the others.
+            #ResetColormap $color
+        }
+        "grid" {
+            SendCmd "grid visible $_settings($this-grid)"
+        }
+        "axes" {
+            SendCmd "axis visible $_settings($this-axes)"
+        }
+        "legend" {
+            if { $_settings($this-legend) } {
                 blt::table $itk_component(plotarea) \
                     0,0 $itk_component(3dview) -fill both \
@@ -1277,70 +1268,14 @@
             }
         }
-        "-light" {
-            set _settings($_current${what}) $_settings($what)
-            set val $_settings($what)
-            set diffuse [expr {0.01*$val}]
-            set ambient [expr {1.0-$diffuse}]
-            set specularLevel 0.3
-            set specularExp 90.0
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume shading ambient $ambient $tag"
-                SendCmd "volume shading diffuse $diffuse $tag"
-                SendCmd "volume shading specularLevel $specularLevel $tag"
-                SendCmd "volume shading specularExp $specularExp $tag"
-            }
-        }
-        "-light2side" {
-            set _settings($_current${what}) $_settings($what)
-            set val $_settings($what)
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume shading light2side $val $tag"
-            }
-        }
-        "-outlinevisible" {
-            SendCmd "volume outline state $_settings($what)"
-        }
-        "-thickness" {
-            set val $_settings($what)
-            set _settings($_current${what}) $val
-            updateTransferFunctions
-        }
-        "-volume" {
-            # This is the global volume visibility control.  It controls the
-            # visibility of all the all volumes.  Whenever it's changed, you
-            # have to synchronize each of the local controls (see below) with
-            # this.
-            set datasets [CurrentDatasets] 
-            set bool $_settings($what)
-            SendCmd "volume data state $bool $datasets"
-            foreach cname $_componentsList {
-                set _settings($cname-volumevisible) $bool
-            }
-            set _settings(-volumevisible) $bool
-        }
-        "-volumeopacity" {
-            set _settings($what) [expr $_widget($what) * 0.01]
-            set _settings($_current${what}) $_settings($what)
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume shading opacity $_settings($what) $tag"
-            }
-        }
-        "-volumevisible" {
-            # This is the component specific control.  It changes the 
-            # visibility of only the current component.
-            set _settings($_current${what}) $_settings($what)
-            foreach tag [GetDatasetsWithComponent $_current] {
-                SendCmd "volume data state $_settings($what) $tag"
-            }
-        }
-        "-xcutplanevisible" - "-ycutplanevisible" - "-zcutplanevisible" {
-            set axis [string range $what 1 1]
-            set bool $_settings($what)
-            # We only set cutplanes on the first dataset.
+        "volume" {
+            set datasets [CurrentDatasets -cutplanes] 
+            SendCmd "volume data state $_settings($this-volume) $datasets"
+        }
+        "xcutplane" - "ycutplane" - "zcutplane" {
+            set axis [string range $what 0 0]
+            set bool $_settings($this-$what)
             set datasets [CurrentDatasets -cutplanes] 
             set tag [lindex $datasets 0]
-            if { $_settings(-cutplanesvisible) } {
-                SendCmd "cutplane state $bool $axis $tag"
-            }
+            SendCmd "cutplane state $bool $axis $tag"
             if { $bool } {
                 $itk_component(${axis}CutScale) configure -state normal \
@@ -1369,13 +1304,19 @@
     set w [expr {$_width-20}]
     set h [expr {[winfo height $itk_component(legend)]-20-$lineht}]
-    if {$w > 0 && $h > 0 && $_first != "" } {
-        if { [info exists _cname2transferFunction($_current)] } {
-            SendCmd "legend $_current $w $h"
-        }
-    }
-}
-
-#
-# NameTransferFunction --
+    if {$w > 0 && $h > 0 && [array names _activeTfs] > 0 && $_first != "" } {
+        set tag [lindex [CurrentDatasets] 0]
+        if { [info exists _dataset2style($tag)] } {
+            SendCmd "legend $_dataset2style($tag) $w $h"
+        }
+    } else {
+        # Can't do this as this will remove the items associated with the
+        # isomarkers.
+        
+        #$itk_component(legend) delete all
+    }
+}
+
+#
+# NameTransferFunc --
 #
 #       Creates a transfer function name based on the <style> settings in the
@@ -1385,43 +1326,44 @@
 #       server parses the 3D data and sends back the limits via ReceiveData.]
 #
-itcl::body Rappture::NanovisViewer::NameTransferFunction { dataobj cname } {
-    array set styles {
+#       FIXME: The current way we generate transfer-function names completely
+#              ignores the -markers option.  The problem is that we are forced
+#              to compute the name from an increasing complex set of values:
+#              color, levels, marker, opacity.  I think we're stuck doing it
+#              now.
+#
+itcl::body Rappture::NanovisViewer::NameTransferFunc { dataobj cname } {
+    array set style {
         -color BCGYR
         -levels 6
+        -opacity 1.0
         -markers ""
     }
     set tag $dataobj-$cname
-    array set styles [lindex [$dataobj components -style $cname] 0]
-    if { ![info exists _cname2transferFunction($cname)] } {
-        # Get the colormap right now, since it doesn't change with marker
-        # changes.
-        set cmap [ColorsToColormap $styles(-color)]
-        set wmap [list 0.0 0.0 1.0 1.0]
-        set _cname2transferFunction($cname) [list $cmap $wmap]
-        SendCmd [list transfunc define $cname $cmap $wmap]
-    }
-    SendCmd "volume shading transfunc $cname $tag"
-    if { ![info exists _transferFunctionEditors($cname)] } {
-        set _transferFunctionEditors($cname) \
-            [Rappture::TransferFunctionEditor ::\#auto $itk_component(legend) \
-                 $cname \
-                 -command [itcl::code $this updateTransferFunctions]]
-    }
-    set _dataset2style($tag) $cname
-    lappend _style2datasets($cname) $tag
-    return $cname
-}
-
-#
-# ComputeTransferFunction --
-#
-#       Computes and sends the transfer function to the render server.  It's
-#       assumed that the volume data limits are known and that the global
-#       transfer-functions slider values have been set up.  Both parts are
-#       needed to compute the relative value (location) of the marker, and
-#       the alpha map of the transfer function.
-#
-itcl::body Rappture::NanovisViewer::ComputeTransferFunction { cname } {
-    foreach {cmap wmap} $_cname2transferFunction($cname) break
+    array set style [lindex [$dataobj components -style $cname] 0]
+    set tf "$style(-color):$style(-levels):$style(-opacity)"
+    set _dataset2style($tag) $tf
+    lappend _style2datasets($tf) $tag
+    return $tf
+}
+
+#
+# ComputeTransferFunc --
+#
+#   Computes and sends the transfer function to the render server.  It's
+#   assumed that the volume data limits are known and that the global
+#   transfer-functions slider values have been set up.  Both parts are
+#   needed to compute the relative value (location) of the marker, and
+#   the alpha map of the transfer function.
+#
+itcl::body Rappture::NanovisViewer::ComputeTransferFunc { tf } {
+    array set style {
+        -color BCGYR
+        -levels 6
+        -opacity 1.0
+        -markers ""
+    }
+
+    foreach {dataobj cname} [split [lindex $_style2datasets($tf) 0] -] break
+    array set style [lindex [$dataobj components -style $cname] 0]
 
     # We have to parse the style attributes for a volume using this
@@ -1431,45 +1373,80 @@
     # of the volumes (the first in the list) using the transfer-function as a
     # reference.
-    if { ![info exists _parsedFunction($cname)] } {
-        array set styles {
-            -color BCGYR
-            -levels 6
-            -markers ""
-        }
-        # Accumulate the style from all the datasets using it.
-        foreach tag [GetDatasetsWithComponent $cname] {
-            foreach {dataobj cname} [split [lindex $tag 0] -] break
-            array set styles [lindex [$dataobj components -style $cname] 0]
-        }
-        eval $_transferFunctionEditors($cname) limits $_limits($cname)
+    #
+    # FIXME: The current way we generate transfer-function names completely 
+    #        ignores the -markers option.  The problem is that we are forced 
+    #        to compute the name from an increasing complex set of values: 
+    #        color, levels, marker, opacity.  I think the cow's out of the
+    #        barn on this one.
+
+    if { ![info exists _isomarkers($tf)] } {
         # Have to defer creation of isomarkers until we have data limits
-        if { [info exists styles(-markers)] &&
-             [llength $styles(-markers)] > 0 } {
-            ParseMarkersOption $cname $styles(-markers)
+        if { [info exists style(-markers)] &&
+             [llength $style(-markers)] > 0 } {
+            ParseMarkersOption $tf $style(-markers)
         } else {
-            ParseLevelsOption $cname $styles(-levels)
-        }
-        
-    }
-    set wmap [ComputeAlphamap $cname]
-    set _cname2transferFunction($cname) [list $cmap $wmap]
-    SendCmd [list transfunc define $cname $cmap $wmap]
-}
-
-itcl::body Rappture::NanovisViewer::AddNewMarker { x y } {
-    if { ![info exists _transferFunctionEditors($_current)] } {
-        continue
-    }
-    # Add a new marker to the current transfer function
-    $_transferFunctionEditors($_current) newMarker $x $y normal
-    $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
-}
-
-itcl::body Rappture::NanovisViewer::RemoveMarker { x y } {
-    if { ![info exists _transferFunctionEditors($_current)] } {
-        continue
-    }
-    # Add a new marker to the current transfer function
-    $_transferFunctionEditors($_current) deleteMarker $x $y 
+            ParseLevelsOption $tf $style(-levels)
+        }
+    }
+    set cmap [ColorsToColormap $style(-color)]
+    set tag $this-$tf
+    if { ![info exists _settings($tag-opacity)] } {
+        set _settings($tag-opacity) $style(-opacity)
+    }
+    set max 1.0 ;#$_settings($tag-opacity)
+
+    set isovalues {}
+    foreach m $_isomarkers($tf) {
+        lappend isovalues [$m relval]
+    }
+    # Sort the isovalues
+    set isovalues [lsort -real $isovalues]
+
+    if { ![info exists _settings($tag-thickness)]} {
+        set _settings($tag-thickness) 0.005
+    }
+    set delta $_settings($tag-thickness)
+
+    set first [lindex $isovalues 0]
+    set last [lindex $isovalues end]
+    set wmap ""
+    if { $first == "" || $first != 0.0 } {
+        lappend wmap 0.0 0.0
+    }
+    foreach x $isovalues {
+        set x1 [expr {$x-$delta-0.00001}]
+        set x2 [expr {$x-$delta}]
+        set x3 [expr {$x+$delta}]
+        set x4 [expr {$x+$delta+0.00001}]
+        if { $x1 < 0.0 } {
+            set x1 0.0
+        } elseif { $x1 > 1.0 } {
+            set x1 1.0
+        }
+        if { $x2 < 0.0 } {
+            set x2 0.0
+        } elseif { $x2 > 1.0 } {
+            set x2 1.0
+        }
+        if { $x3 < 0.0 } {
+            set x3 0.0
+        } elseif { $x3 > 1.0 } {
+            set x3 1.0
+        }
+        if { $x4 < 0.0 } {
+            set x4 0.0
+        } elseif { $x4 > 1.0 } {
+            set x4 1.0
+        }
+        # add spikes in the middle
+        lappend wmap $x1 0.0
+        lappend wmap $x2 $max
+        lappend wmap $x3 $max
+        lappend wmap $x4 0.0
+    }
+    if { $last == "" || $last != 1.0 } {
+        lappend wmap 1.0 0.0
+    }
+    SendCmd "transfunc define $tf { $cmap } { $wmap }"
 }
 
@@ -1479,8 +1456,7 @@
 itcl::configbody Rappture::NanovisViewer::plotbackground {
     if { [isconnected] } {
-        set color $itk_option(-plotbackground)
-        set rgb [Color2RGB $color]
-        SendCmd "screen bgcolor $rgb"
-        $itk_component(legend) configure -background $color
+        foreach {r g b} [Color2RGB $itk_option(-plotbackground)] break
+        #fix this!
+        #SendCmd "color background $r $g $b"
     }
 }
@@ -1491,11 +1467,7 @@
 itcl::configbody Rappture::NanovisViewer::plotforeground {
     if { [isconnected] } {
-        set color $itk_option(-plotforeground)
-        set rgb [Color2RGB $color]
-        SendCmd "volume outline color $rgb"
-        SendCmd "grid axiscolor $rgb"
-        SendCmd "grid linecolor $rgb"
-        $itk_component(legend) itemconfigure labels -fill $color 
-        $itk_component(legend) itemconfigure limits -fill $color 
+        foreach {r g b} [Color2RGB $itk_option(-plotforeground)] break
+        #fix this!
+        #SendCmd "color background $r $g $b"
     }
 }
@@ -1524,20 +1496,21 @@
 # marker is a relative value from 0.0 to 1.0.
 #
-itcl::body Rappture::NanovisViewer::ParseLevelsOption { cname levels } {
+itcl::body Rappture::NanovisViewer::ParseLevelsOption { tf levels } {
     set c $itk_component(legend)
-    set list {}
     regsub -all "," $levels " " levels
     if {[string is int $levels]} {
         for {set i 1} { $i <= $levels } {incr i} {
-            lappend list [expr {double($i)/($levels+1)}]
+            set x [expr {double($i)/($levels+1)}]
+            set m [Rappture::IsoMarker \#auto $c $this $tf]
+            $m relval $x
+            lappend _isomarkers($tf) $m 
         }
     } else {
         foreach x $levels {
-            lappend list $x
-        }
-    }
-    set _parsedFunction($cname) 1
-    $_transferFunctionEditors($cname) addMarkers $list
-    $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
+            set m [Rappture::IsoMarker \#auto $c $this $tf]
+            $m relval $x
+            lappend _isomarkers($tf) $m 
+        }
+    }
 }
 
@@ -1554,22 +1527,22 @@
 #       not be seen.
 #
-itcl::body Rappture::NanovisViewer::ParseMarkersOption { cname markers } {
+itcl::body Rappture::NanovisViewer::ParseMarkersOption { tf markers } {
     set c $itk_component(legend)
-    set list {}
-    foreach { min max } $_limits($cname) break
     regsub -all "," $markers " " markers
     foreach marker $markers {
         set n [scan $marker "%g%s" value suffix]
         if { $n == 2 && $suffix == "%" } {
-            # $n% : Set relative value (0..1). 
-            lappend list [expr {$value * 0.01}]
+            # ${n}% : Set relative value. 
+            set value [expr {$value * 0.01}]
+            set m [Rappture::IsoMarker \#auto $c $this $tf]
+            $m relval $value
+            lappend _isomarkers($tf) $m
         } else {
-            # $n : absolute value, compute relative
-            lappend list  [expr {(double($value)-$min)/($max-$min)]}
-        }
-    }
-    set _parsedFunction($cname) 1
-    $_transferFunctionEditors($cname) addMarkers $list
-    $itk_component(legend) itemconfigure labels -fill $itk_option(-plotforeground)
+            # ${n} : Set absolute value.
+            set m [Rappture::IsoMarker \#auto $c $this $tf]
+            $m absval $value
+            lappend _isomarkers($tf) $m
+        }
+    }
 }
 
@@ -1577,25 +1550,82 @@
 # USAGE: UndateTransferFuncs 
 # ----------------------------------------------------------------------
-itcl::body Rappture::NanovisViewer::updateTransferFunctions {} {
+itcl::body Rappture::NanovisViewer::updatetransferfuncs {} {
     $_dispatcher event -idle !send_transfunc
 }
 
-itcl::body Rappture::NanovisViewer::limits { cname } {
+itcl::body Rappture::NanovisViewer::AddIsoMarker { x y } {
+    if { $_first == "" } {
+        error "active transfer function isn't set"
+    }
+    set tag [lindex [CurrentDatasets] 0]
+    set tf $_dataset2style($tag)
+    set c $itk_component(legend)
+    set m [Rappture::IsoMarker \#auto $c $this $tf]
+    set w [winfo width $c]
+    $m relval [expr {double($x-10)/($w-20)}]
+    lappend _isomarkers($tf) $m
+    updatetransferfuncs
+    return 1
+}
+
+itcl::body Rappture::NanovisViewer::rmdupmarker { marker x } {
+    set tf [$marker transferfunc]
+    set bool 0
+    if { [info exists _isomarkers($tf)] } {
+        set list {}
+        set marker [namespace tail $marker]
+        foreach m $_isomarkers($tf) {
+            set sx [$m screenpos]
+            if { $m != $marker } {
+                if { $x >= ($sx-3) && $x <= ($sx+3) } {
+                    $marker relval [$m relval]
+                    itcl::delete object $m
+                    bell
+                    set bool 1
+                    continue
+                }
+            }
+            lappend list $m
+        }
+        set _isomarkers($tf) $list
+        updatetransferfuncs
+    }
+    return $bool
+}
+
+itcl::body Rappture::NanovisViewer::overmarker { marker x } {
+    set tf [$marker transferfunc]
+    if { [info exists _isomarkers($tf)] } {
+        set marker [namespace tail $marker]
+        foreach m $_isomarkers($tf) {
+            set sx [$m screenpos]
+            if { $m != $marker } {
+                set bool [expr { $x >= ($sx-3) && $x <= ($sx+3) }]
+                $m activate $bool
+            }
+        }
+    }
+    return ""
+}
+
+itcl::body Rappture::NanovisViewer::limits { tf } {
     set _limits(min) 0.0
     set _limits(max) 1.0
-    if { ![info exists _style2datasets($cname)] } {
+    if { ![info exists _style2datasets($tf)] } {
         return [array get _limits]
     }
     set min ""; set max ""
-    foreach tag [GetDatasetsWithComponent $cname] {
-        if { ![info exists _limits($tag)] } {
+    foreach tag $_style2datasets($tf) {
+        if { ![info exists _serverDatasets($tag)] } {
             continue
         }
-        foreach {amin amax} $_limits($tag) break
-        if { $min == "" || $min > $amin } {
-            set min $amin
-        }
-        if { $max == "" || $max < $amax } {
-            set max $amax
+        if { ![info exists _limits($tag-min)] } {
+            continue
+        }
+        if { $min == "" || $min > $_limits($tag-min) } {
+            set min $_limits($tag-min)
+        }
+        if { $max == "" || $max < $_limits($tag-max) } {
+            set max $_limits($tag-max)
         }
     }
@@ -1606,9 +1636,21 @@
         set _limits(max) $max
     }
-    return [list $_limits(min) $_limits(max)]
+    return [array get _limits]
 }
 
 
 itcl::body Rappture::NanovisViewer::BuildViewTab {} {
+    foreach { key value } {
+        grid            0
+        axes            1
+        outline         0
+        volume          1
+        legend          1
+        particles       1
+        lic             1
+    } {
+        set _settings($this-$key) $value
+    }
+
     set fg [option get $itk_component(hull) font Font]
     #set bfg [option get $itk_component(hull) boldFont Font]
@@ -1619,53 +1661,40 @@
     $inner configure -borderwidth 4
 
-    set ::Rappture::NanovisViewer::_settings(-isosurfaceshading) 0
+    set ::Rappture::NanovisViewer::_settings($this-isosurface) 0
     checkbutton $inner.isosurface \
         -text "Isosurface shading" \
-        -variable [itcl::scope _settings(-isosurfaceshading)] \
-        -command [itcl::code $this AdjustSetting -isosurfaceshading] \
+        -variable [itcl::scope _settings($this-isosurface)] \
+        -command [itcl::code $this AdjustSetting isosurface] \
         -font "Arial 9"
 
     checkbutton $inner.axes \
         -text "Axes" \
-        -variable [itcl::scope _settings(-axesvisible)] \
-        -command [itcl::code $this AdjustSetting -axesvisible] \
+        -variable [itcl::scope _settings($this-axes)] \
+        -command [itcl::code $this AdjustSetting axes] \
         -font "Arial 9"
 
     checkbutton $inner.grid \
         -text "Grid" \
-        -variable [itcl::scope _settings(-gridvisible)] \
-        -command [itcl::code $this AdjustSetting -gridvisible] \
+        -variable [itcl::scope _settings($this-grid)] \
+        -command [itcl::code $this AdjustSetting grid] \
         -font "Arial 9"
 
     checkbutton $inner.outline \
         -text "Outline" \
-        -variable [itcl::scope _settings(-outlinevisible)] \
-        -command [itcl::code $this AdjustSetting -outlinevisible] \
+        -variable [itcl::scope _settings($this-outline)] \
+        -command [itcl::code $this AdjustSetting outline] \
         -font "Arial 9"
 
     checkbutton $inner.legend \
         -text "Legend" \
-        -variable [itcl::scope _settings(-legendvisible)] \
-        -command [itcl::code $this AdjustSetting -legendvisible] \
+        -variable [itcl::scope _settings($this-legend)] \
+        -command [itcl::code $this AdjustSetting legend] \
         -font "Arial 9"
 
     checkbutton $inner.volume \
         -text "Volume" \
-        -variable [itcl::scope _settings(-volume)] \
-        -command [itcl::code $this AdjustSetting -volume] \
+        -variable [itcl::scope _settings($this-volume)] \
+        -command [itcl::code $this AdjustSetting volume] \
         -font "Arial 9"
-
-    label $inner.background_l -text "Background" -font "Arial 9" 
-    itk_component add background {
-        Rappture::Combobox $inner.background -width 10 -editable no
-    }
-    $inner.background choices insert end \
-        "black"              "black"            \
-        "white"              "white"            \
-        "grey"               "grey"             
-
-    $itk_component(background) value $_settings(-background)
-    bind $inner.background <<Value>> \
-        [itcl::code $this AdjustSetting -background]
 
     blt::table $inner \
@@ -1674,7 +1703,5 @@
         2,0 $inner.outline  -cspan 2 -anchor w \
         3,0 $inner.volume  -cspan 2 -anchor w \
-        4,0 $inner.legend  -cspan 2 -anchor w \
-        5,0 $inner.background_l       -anchor e -pady 2 \
-        5,1 $inner.background                   -fill x \
+        4,0 $inner.legend  -cspan 2 -anchor w 
 
     if 0 {
@@ -1682,8 +1709,18 @@
     }
     blt::table configure $inner r* -resize none
-    blt::table configure $inner r6 -resize expand
+    blt::table configure $inner r5 -resize expand
 }
 
 itcl::body Rappture::NanovisViewer::BuildVolumeTab {} {
+    foreach { key value } {
+        light2side      1
+        light           40
+        transp          50
+        opacity         100
+        thickness       350
+    } {
+        set _settings($this-$key) $value
+    }
+
     set inner [$itk_component(main) insert end \
         -title "Volume Settings" \
